OpenVDB: CheckNormGrad< GridT, TreeIterT, GradScheme > Struct Template Reference

OpenVDB 10.0.1

Public Types | Public Member Functions | Public Attributes | List of all members
CheckNormGrad< GridT, TreeIterT, GradScheme > Struct Template Reference

Checks the norm of the gradient against a range, i.e., |∇Φ| ∈ [min, max]. More...

`#include <openvdb/tools/Diagnostics.h>`

## Public Types
using | ValueType = typename GridT::ValueType
using | TileIterT = TreeIterT
using | VoxelIterT = typename tree::IterTraits< typename TreeIterT::NodeT, typename TreeIterT::ValueIterT > ::template NodeConverter< typename GridT::TreeType::LeafNodeType >::Type
using | AccT = typename GridT::ConstAccessor

## Public Member Functions
| CheckNormGrad (const GridT &grid, const ValueType &_min, const ValueType &_max)
| Constructor taking a grid and a range to be tested against. More...
| CheckNormGrad (const CheckNormGrad &other)
bool | operator() (const ValueType &v) const
| Return true if the value is smaller than min or larger than max. More...
bool | operator() (const TreeIterT &) const
| Return true if zero is outside the range. More...
bool | operator() (const VoxelIterT &iter) const
| Return true if the norm of the gradient at a voxel location of the iterator is out of range. More...
std::string | str () const
| Return a string describing a failed check. More...

## Public Attributes
AccT | acc
const ValueType | invdx2
const ValueType | minVal2
const ValueType | maxVal2

## Detailed Description

template<typename GridT, typename TreeIterT = typename GridT::ValueOnCIter, math::BiasedGradientScheme GradScheme = math::FIRST_BIAS>
struct openvdb::v10_0::tools::CheckNormGrad< GridT, TreeIterT, GradScheme >

Checks the norm of the gradient against a range, i.e., |∇Φ| ∈ [min, max].

Note
  Internally the test is performed as |∇Φ|² ∈ [min², max²] for optimization reasons.

## Member Typedef Documentation

## ◆ AccT

using AccT = typename GridT::ConstAccessor

## ◆ TileIterT

using TileIterT = TreeIterT

## ◆ ValueType

using ValueType = typename GridT::ValueType

## ◆ VoxelIterT

using VoxelIterT = typename tree::IterTraits<typename TreeIterT::NodeT, typename TreeIterT::ValueIterT> ::template NodeConverter< typename GridT::TreeType::LeafNodeType>::Type

## Constructor & Destructor Documentation

## ◆ CheckNormGrad() [1/2]

CheckNormGrad | ( | const GridT & | grid,
|  | const ValueType & | _min,
|  | const ValueType & | _max
| ) |  |
| inline

Constructor taking a grid and a range to be tested against.

## ◆ CheckNormGrad() [2/2]

CheckNormGrad | ( | const CheckNormGrad< GridT, TreeIterT, GradScheme > & | other | ) |
| inline

## Member Function Documentation

## ◆ operator()() [1/3]

bool operator() | ( | const TreeIterT & |  | ) | const
| inline

Return true if zero is outside the range.

Note
  We assume that the norm of the gradient of a tile is always zero.

## ◆ operator()() [2/3]

bool operator() | ( | const ValueType & | v | ) | const
| inline

Return true if the value is smaller than min or larger than max.

## ◆ operator()() [3/3]

bool operator() | ( | const VoxelIterT & | iter | ) | const
| inline

Return true if the norm of the gradient at a voxel location of the iterator is out of range.

## ◆ str()

std::string str | ( |  | ) | const
| inline

Return a string describing a failed check.

## Member Data Documentation

## ◆ acc

AccT acc

## ◆ invdx2

const ValueType invdx2

## ◆ maxVal2

const ValueType maxVal2

## ◆ minVal2

const ValueType minVal2